Description

With state def's, one can set a length of -1 to make the mobj never leave that state, but -1 doesn't appear to work with texture
animation definitions; Dday appears to interpret it as 1 tic.

| wasn't sure if this was a bug or support for -1 tic lengths in texture animations was never added.
| was toying with the idea of a sky that changed into a different one over time, only to find out both that smooth texture animation

didn't work with skies (it works with textures and flats as long as they have no transparent part's) and that sky glows and the
associated coloured sector lighting don't appear to change if the sky changes.

Associated revisions

Revision 8611285 - 2015-03-06 22:03 - danij

Fixed|Definitions|libdoomsday: Group definition frame duration validation (mishandled -1)

Do not handle Group definitions whose frame durations do not describe
a valid animation sequence, when generating Material animations.

A warning is now logged by the DED parser when an invalid duration is
encountered. The Group definition itself will be ignored when building
Material animations, later on.

IssuelD #1896

History

#1 - 2014-11-06 14:00 - vermil

Apologies for arguably reporting several things in one report (I got carried away writing).

#2 - 2014-11-06 15:04 - danij

Something I'd like to do in a future version is redesign how the sky-glow is sampled. Presently this works by evaluating the colors of the sky textures
at load time. This is fine for the skydome where we have prior knowledge about the geometry, but model skies can't be dealt with in the same way.

The solution I'd like to use here is to render the sky to a very low quality cube map and sample the sky-glow color using this instead. That way, it'll
work independent of the sky geometry and can be sampled in "real time" (in reality, a delay of a few tics wouldn't hurt if the sampling results were
animated with interpolation).

Naturally there are other benefits to using a cube map. Specifically, we'd be able to determine if there is a strong light source in the sky and determine
an approximate origin vector in 3D space. Once such a vector is obtained we'd be able to do more interesting lighting in outdoor areas.

#3 - 2015-02-02 11:49 - skyjake
- Tags set to Textures, Materials, Animation, Sky

- Category set to Defect

#4 - 2015-03-03 06:08 - danij
- Status changed from New to Feedback

- Assignee set to vermil

vermil: How are you specifying a duration of -1 tics? Using the old Group method? (I don't believe a duration of -1 has ever been supported in a
Group def).

It would be very helpful to see an example of what you are trying to do.
#5 - 2015-03-05 12:15 - vermil

| was indeed specifying -1 in a group def. As | wrote above, | wasn't sure if it was a bug or a never supported feature.

| simply wanted a standard sky texture to change into another on it's own, over the course of a map.

#6 - 2015-03-06 19:59 - danij

| see. Yeah a duration of Group.Flat/Texture.Tics = -1 has never been supported as there is no "infinite" concept at Group level. At the least the
parser should catch this and log a warning...

It sounds like you're trying to set things up so that there is a one-time animation which when complete, switches to a separate looped animation? If so
then this is far beyond the scope of what a Group is intended for.

Once support for multi-layered Materials has been completed we can then revise the sky dome renderer to use the full material system feature set,
removing the special case layer mechanic used for sky layers. At which point, scripting up sky material changes as you'd like should be more doable.

#7 - 2015-03-06 20:03 - danij
- Tags changed from Textures, Materials, Animation, Sky to Textures, Materials, Animation, Definitions

- Subject changed from texture animation; -1 tic length mis-interpreted as 1 tic to Validating Group def tic durations (value -1 is
mishandled/unsupported)

- Status changed from Feedback to In Progress

- Assignee changed from vermil to danij

#8 - 2015-03-06 22:04 - danij
- Status changed from In Progress to Resolved
- Target version setto 1.15

- % Done changed from 0 to 100

#9 - 2015-03-07 04:11 - danij

- Status changed from Resolved to Closed
